<?php
if (!defined("TKM")) {
	die("<pre>Access denied!</pre>");
}

$page['title']   = "Статические страницы";
$page['pid']	 = "pages";

$do = (isset($_GET['do'])) ? $_GET['do'] : 'list';

switch ($do) {
	case 'add':
		$page['title']   = "Добавить страницу";

		if ($_SERVER['REQUEST_METHOD'] === "POST") {
			if (empty($_POST['name']) || empty($_POST['title']) || empty($_POST['text'])) {
				MessageSend(1, "Заполните все поля!");
			}

			$name   = trim($_POST['name']);
			$title  = trim($_POST['title']);
			$text   = $_POST['text'];
			$adv	= (isset($_POST['adv']) && $_POST['adv'] == 'on') ? 1 : 0;

			$checkName = $link->prepare("SELECT `id` FROM `AD_PAGES` WHERE `name` = ? LIMIT 1");

			if (!$checkName->execute([$name])) {
				MessageSend(1, "Ошибка БД!");
			}

			if ($checkName->rowCount() >= 1) {
				MessageSend(1, "Такой идентификатор уже используется!");
			}

			$link->prepare("INSERT INTO `AD_PAGES` (`name`, `title`, `text`, `adv`) VALUES (?, ?, ?, ?)")->execute([
				$name,
				$title,
				$text,
				$adv
			]);
			MessageSend(3, "Страница успешно создана!", '?mode=pages');
		}

		$page['content'] = loadTpl('/admin/pages/edit.html');
		break;

	case 'edit':
		$page['title']   = "Изменить страницу";

		if (!isset($_GET['id']) || !is_numeric($_GET['id']) || $_GET['id'] < 0) {
			MessageSend(1, "Страница не найдена!");
		}

		$id = (int) $_GET['id'];
		$pageRow = $link->query("SELECT * FROM `AD_PAGES` WHERE `id` = '{$id}' LIMIT 1");

		if ($pageRow->rowCount() <= 0) {
			MessageSend(1, "Страница не найдена!");
		}

		$pageRow = $pageRow->fetch();

		if ($_SERVER['REQUEST_METHOD'] === "POST") {
			if (empty($_POST['name']) || empty($_POST['title']) || empty($_POST['text'])) {
				MessageSend(1, "Заполните все поля!");
			}

			$name   = trim($_POST['name']);
			$title  = trim($_POST['title']);
			$text   = $_POST['text'];
			$adv	= (isset($_POST['adv']) && $_POST['adv'] == 'on') ? 1 : 0;

			$link->prepare("UPDATE `AD_PAGES` SET `name` = ?, `title` = ?, `text` = ?, `adv` = ? WHERE `id` = ? LIMIT 1")->execute([
				$name,
				$title,
				$text,
				$adv,
				$id,
			]);
			MessageSend(3, "Страница успешно изменена!", '?mode=pages');
		}

		$page['content'] = loadTpl('/admin/pages/edit.html', $pageRow);
		break;

	case 'remove':
		$page['title']   = "Удалить страницу";

		if ($_SERVER['REQUEST_METHOD'] === "POST") {
			if (!isset($_GET['id']) || !is_numeric($_GET['id']) || $_GET['id'] < 0) {
				MessageSend(1, "Страница не найдена!", '?mode=pages');
			}

			$id = (int)$_GET['id'];
			$pageRow = $link->query("SELECT * FROM `AD_PAGES` WHERE `id` = '{$id}' LIMIT 1");

			if ($pageRow->rowCount() <= 0) {
				MessageSend(1, "Страница не найдена!", '?mode=pages');
			}

			$link->query("DELETE FROM `AD_PAGES` WHERE `id` = '{$id}' LIMIT 1");
			MessageSend(3, "Страница успешно удалена!", '?mode=pages');
		}

		$page['content'] = loadTpl('/admin/check.html');
		break;

	default:
	case 'list':
		$pagesList = $link->query("SELECT `id`, `name`, `title` FROM `AD_PAGES` ORDER BY `id` DESC");
		$pages = '';

		foreach ($pagesList as $pageItem) {
			$pages .= loadTpl('/admin/pages/list_item.html', $pageItem);
		}

		if (empty($pages)) {
			$pages = '<tr><td class="text-center text-danger" colspan="5">Вы ещё не добавили страниц!</td></tr>';
		}

		$page['content'] = loadTpl('/admin/pages/list.html', $pages);
		break;
}