<?php
if (!defined("TKM")) {
    die("<pre>Access denied!</pre>");
}

class Payment
{
    private $payment_isset, $data, $data2;
    public $payment_id;
    private static $mVkCount = 0;
    private static $uuidCache = ['offline' => [], 'mojang' => [], 'custom' => []];

    public function select($paymentID, $summ = "-")
    {
        global $link, $config;
        $row = $link->query("SELECT * FROM `AD_PAYMENTS` WHERE `id` = '{$paymentID}'")->fetch();

        if (empty($row['username'])) return "Payment not found!";

        $data = json_decode($row['data'], true);

        if ($summ != '-' && (int)$summ != (int)$data['cost'])
            return "Not valid cost! Gived: {$summ}, Valid: {$data['cost']}";

        if ($row['server'] <= (count($config['servers']) - 1) && $row['server'] >= 0)
            $server = $row['server'];
        else return "Не найден сервер для выдачи!";

        $data = json_decode($row['data'], true);
        $row2 = $link->query("SELECT * FROM `AD_GOODS` WHERE `id` = '{$data['goods_id']}'")->fetch();

        if (empty($row2['id'])) {
            return "Товар не найден! (ID: {$data['goods_id']})";
        }

        $this->payment_isset = true;
        $this->data = $row;
        $this->data2 = $row2;
        $this->payment_id = $paymentID;

        return true;
    }

    public function give($admin = false)
    {
        global $link, $config;

        if (!$this->payment_isset) return "Платёж не найден!";

        if (empty($this->data['stime'])) {
            $link->prepare("UPDATE `AD_PAYMENTS` SET `stime` = ? WHERE `id` = ? LIMIT 1")->execute([
                time(),
                $this->payment_id
            ]);
        }

        $data = json_decode($this->data['data'], true);
        $commands = json_decode($this->data2['commands'], true);

        $rcon = new RCON($this->data['server']);

        if (!@$rcon->connect()) {
            $link->prepare(
                "UPDATE `AD_PAYMENTS` SET `status` = 2, `log` = 'Нет подключения к серверу!' WHERE `id` = '{$this->payment_id}'"
            )->execute();

            if (!empty($config['vk']['accessToken'])) {
                $this->sendVkMessage(
                    'Не удалось подключиться к игровому серверу (' .
                    $config['servers'][$this->data['server']]['name'] .
                    ') по RCON! Платёж: #' . $this->payment_id,
                    array_values($config['vk']['accs'])
                );
            }


            return "Нет подключения к серверу!";
        }

        for ($i = 0; $i < count($commands); $i++) {
            $command = str_replace("{user}", $this->data['username'], $commands[$i]);
            $log[] = '> ' . $command;

            try {
                $command = str_replace("{mojang_uuid}",
                    self::getUUID($this->data['username'], 'mojang'), $command);
                $command = str_replace("{offline_uuid}",
                    self::getUUID($this->data['username'], 'offline'), $command);
                $command = str_replace("{custom_uuid}",
                    self::getUUID($this->data['username'], 'custom'), $command);
            } catch (Exception $ex) {
                $log[] = 'ОШИБКА UUID: ' . trim($ex->getMessage());
            }

            if (@substr($command, 0, 4) == "sql:") {
                $command = str_replace('\\\\\\u0027', "'", $command);
                $command = str_replace('\\\\', '', $command);
                $command = str_replace("\\'", "'", $command);

                try {
                    $link->prepare(substr($command, 4))->execute();
                    $log[] = "SQL-запрос успешно выполнен!";
                } catch (Exception $ex) {
                    $log[] = "ОШИБКА-SQL: " . trim($ex->getMessage());
                }
            } else {



                try {
                    $rcon->send_command($command);
                    $log[] = trim($rcon->get_response());
                } catch (Exception $ex) {
                    $log[] = "ОШИБКА: ";
                }
            }
        }

        $rcon->disconnect();
        $log = json_encode($log, JSON_UNESCAPED_UNICODE | JSON_HEX_QUOT | JSON_HEX_APOS);

        $link->prepare(
            "UPDATE `AD_PAYMENTS` SET `status` = 1, `log` = '{$log}' WHERE `id` = '{$this->payment_id}'"
        )->execute();
        $link->prepare(
            "INSERT INTO `AD_BUYERS` VALUES (NULL, :username, :good, :ctime, :exptime, :cost, :server)"
        )->execute(
            array(
                'username' => $this->data['username'],
                'good' => $this->data2['id'],
                'ctime' => time(), 'exptime' => 0,
                'cost' => $data['cost'],
                'server' => $this->data['server']
            )
        );

        if (!empty($config['vk']['accessToken'])) {
            $this->sendVkMessage(
                "Игрок {$this->data['username']} купил товар {$this->data2['name']}, за: {$data['cost']}руб. Платёж: #" . $this->payment_id,
                array_values($config['vk']['accs'])
            );
        }

        return true;
    }

    private function sendVkMessage($message, $uid)
    {
        global $config;
        if ((self::$mVkCount % 3) == 0) sleep(1);

        if (is_array($uid)) $uid = implode(',', $uid);

        $request_params = array(
            'message' => $message,
            'user_ids' => $uid,
            'access_token' => $config['vk']['accessToken'],
            'v' => '5.80'
        );

        @file_get_contents('https://api.vk.com/method/messages.send?' . http_build_query($request_params));

        self::$mVkCount++;
    }

    public function create($username, $data, $server)
    {
        global $link;

        $sql = $link->prepare("INSERT INTO AD_PAYMENTS (`username`, `data`, `time`, `status`, `server`) VALUES (:username, :data, '" . time() . "', 0, '{$server}')");
        $sql->execute(array("username" => $username, "data" => $data));
        $this->payment_id = $link->lastInsertId();

        return true;
    }

    public static function getUUID($username, $type)
    {
        global $config;

        switch ($type) {
            default:
            case 'offline':
                if (isset(self::$uuidCache['offline'][$username])) return self::$uuidCache['offline'][$username];

                try {
                    self::$uuidCache['offline'][$username] = self::uuidFromString('OfflinePlayer:' . $username);
                    return self::$uuidCache['offline'][$username];
                } catch (Exception $exception) {
                    throw new Exception("Не удалось получить Offline UUID: " . $exception->getMessage());
                }
                break;

            case 'mojang':
                if (isset(self::$uuidCache['mojang'][$username])) return self::$uuidCache['mojang'][$username];
                try {
                    $data = file_get_contents('https://api.mojang.com/users/profiles/minecraft/' . $username);
                    $data = json_decode($data, true);

                    self::$uuidCache['mojang'][$username] = $data['id'];
                    return self::$uuidCache['mojang'][$username];
                } catch (Exception $exception) {
                    throw new Exception("Не удалось получить Mojang UUID: " . $exception->getMessage());
                }
                break;

            case 'custom':
                if (empty($config['main']['customUUID'])) return false;

                if (isset(self::$uuidCache['custom'][$username])) return self::$uuidCache['custom'][$username];
                try {
                    $data = file_get_contents(@($config['main']['customUUID']) . $username);
                    $data = json_decode($data, true);

                    self::$uuidCache['custom'][$username] = $data['uuid'];
                    return self::$uuidCache['custom'][$username];
                } catch (Exception $exception) {
                    throw new Exception("Не удалось получить Custom UUID: " . $exception->getMessage());
                }
                break;
        }

        return false;
    }

    /**
     * (c) alexandrage
     * https://github.com/alexandrage/Fix-Sashok/blob/master/site/uuid.php
     */
    public static function uuidFromString($string)
    {
        $val = md5($string, true);
        $byte = array_values(unpack('C16', $val));

        $tLo = ($byte[0] << 24) | ($byte[1] << 16) | ($byte[2] << 8) | $byte[3];
        $tMi = ($byte[4] << 8) | $byte[5];
        $tHi = ($byte[6] << 8) | $byte[7];
        $csLo = $byte[9];
        $csHi = $byte[8] & 0x3f | (1 << 7);

        if (pack('L', 0x6162797A) == pack('N', 0x6162797A)) {
            $tLo = (($tLo & 0x000000ff) << 24) | (($tLo & 0x0000ff00) << 8) | (($tLo & 0x00ff0000) >> 8) | (($tLo & 0xff000000) >> 24);
            $tMi = (($tMi & 0x00ff) << 8) | (($tMi & 0xff00) >> 8);
            $tHi = (($tHi & 0x00ff) << 8) | (($tHi & 0xff00) >> 8);
        }

        $tHi &= 0x0fff;
        $tHi |= (3 << 12);

        $uuid = sprintf(
            '%08x-%04x-%04x-%02x%02x-%02x%02x%02x%02x%02x%02x',
            $tLo, $tMi, $tHi, $csHi, $csLo,
            $byte[10], $byte[11], $byte[12], $byte[13], $byte[14], $byte[15]
        );
        return $uuid;
    }
}