<?php
define("TKM", true);
require(realpath("../../system.php"));

$ip_checked = false;

foreach(array(
	'HTTP_X_CLUSTER_CLIENT_IP',
	'HTTP_X_FORWARDED_FOR',
	'HTTP_X_FORWARDED',
	'HTTP_FORWARDED_FOR',
	'HTTP_FORWARDED',
	'HTTP_CLIENT_IP',
	'REMOTE_ADDR'
) as $param) {
	if (!empty($_SERVER[$param]) && $_SERVER[$param] === '5.196.121.217') {
		$ip_checked = true;
		break;
	}
}

if (!$ip_checked) {
	die('error');
}

foreach(array(
	'uid',
	'amount',
	'amount_shop',
	'amount_client',
	'currency',
	'order_id',
	'payment_method_title',
	'creation_time',
	'client_email',
	'status',
	'signature'
) as $field) {
	if (empty($_POST[$field])) {
		die('error');
	}
}

$uid					= (int) $_POST['uid'];
$amount					= (double) $_POST['amount'];
$amount_shop			= (double) $_POST['amount_shop'];
$amount_client			= (double) $_POST['amount_client'];
$currency				= $_POST['currency'];
$order_id				= $_POST['order_id'];
$payment_method_id		= (int) $_POST['payment_method_id'];
$payment_method_title	= $_POST['payment_method_title'];
$creation_time			= $_POST['creation_time'];
$payment_time			= $_POST['payment_time'];
$client_email			= $_POST['client_email'];
$status					= $_POST['status'];
$debug					= (!empty($_POST['debug'])) ? '1' : '0';
$signature				= $_POST['signature'];

if (!in_array($currency, array('RUB', 'USD', 'EUR'), true)) {
	die('error');
}

if (!in_array($status, array('success', 'fail'), true)) {
	die('error');
}

if (!preg_match('/^[0-9a-f]{32}$/', $signature)) {
	die('error');
}

$signature_calc = md5(join(':', array(
	$uid, $amount, $amount_shop, $amount_client, $currency, $order_id,
	$payment_method_id, $payment_method_title, $creation_time, $payment_time,
	$client_email, $status, $debug, $megakassa['settings']['secret_key'])));

if ($signature_calc !== $signature) {
	die('error');
}

switch ($status) {
	case 'success':
		$payment = new Payment;
		$status = $payment->select($order_id, $amount_shop);

		if (!$status) {
			exit($status);
		}

		$status = $payment->give();

		if (!$status) {
			exit($status);
		}
		break;

	case 'fail':
		break;
}

die('OK');