<?php
ini_set('display_errors', 1);
error_reporting(E_ALL);

if (!defined("TKM")) die("<pre>Access denied!</pre>");

define('LD_ROOT_DIR', dirname(__FILE__));
define('LD_CLASSES_DIR', LD_ROOT_DIR . '/classes');
define('LD_PAYMENTS_DIR', LD_ROOT_DIR . '/payments');
define('LD_STYLE_DIR', LD_ROOT_DIR . '/style');
define('LD_STYLE_URL', '/style');
define('LD_VERSION', '2.9');

session_start();

require(LD_ROOT_DIR . "/config.php");
$config['main']['mainurl'] = $_SERVER['SERVER_NAME'];
require(LD_CLASSES_DIR . "/rcon.class.php");
require(LD_CLASSES_DIR . "/payment.class.php");

if ($config['main']['installed']) {
    try {
        $opt = array(
            PDO::ATTR_ERRMODE => PDO::ERRMODE_EXCEPTION,
            PDO::ATTR_DEFAULT_FETCH_MODE => PDO::FETCH_ASSOC
        );
        $link = @new PDO("mysql:host={$config['main']['db_host']};port={$config['main']['db_port']};dbname={$config['main']['db_name']};charset=utf8", $config['main']['db_user'], $config['main']['db_pass'], $opt);
    } catch (PDOException $ex) {
        exit("{$ex->getMessage()}<p>[Database] Не удалось подключится к БД.</p>");
    }

    if (!empty($config['main']['uPattern'])) {
        define('U_REGEXP', $config['main']['uPattern']);
    } else {
        define('U_REGEXP', '[A-z-0-9._-]{3,20}');
    }
}

function loadTpl($file, $data = [])
{
    global $config;
    $file = LD_STYLE_DIR . $file;
    ob_start();

    if (file_exists($file)) {
        include $file;
    } else {
        echo 'TPL File not found!';
    }

    return ob_get_clean();
}

function TextSave($string)
{
    return htmlspecialchars($string);
}

function MessageSend($type, $message, $location = '')
{
    $data = [
        'type' => 'error',
        'text' => 'Неизвестная ошибка!',
    ];
    switch ($type) {
        case 2:
            $data['type'] = 'warn';
            break;

        case 3:
            $data['type'] = 'success';
            break;

        case 1:
        default:
            $data['type'] = 'error';
            break;
    }
    if (!empty($message)) {
        $data['text'] = $message;
    }

    $_SESSION['message'] = loadTpl('/alert.html', $data);

    if ($location) {
        header("Location: " . $location);
    } else {
        if (isset($_SERVER['HTTP_REFERER'])) {
            header("Location: " . $_SERVER['HTTP_REFERER']);
        } else {
            header("Location: /");
        }
    }

    die;
}

function MessageShow()
{
    if (isset($_SESSION['message'])) {
        echo $_SESSION['message'];
        unset($_SESSION['message']);
    }
}

function savecfg()
{
    global $config;

    $txt = '<?php' . PHP_EOL;
    $txt .= 'if (!defined("TKM")) die("<pre>Access denied!</pre>");' . PHP_EOL;
    $txt .= "//Generated with love!" . PHP_EOL;
    $txt .= '$config = ' . var_export($config, true) . ';' . PHP_EOL;

    $result = file_put_contents(LD_ROOT_DIR . "/config.php", $txt);

    if ($result === false) {
        return false;
    }

    return true;
}

function getIP()
{
    if (isset($_SERVER['HTTP_CF_CONNECTING_IP'])) {
        //CloudFlare proxy Support
        $ip = $_SERVER['HTTP_CF_CONNECTING_IP'];
    } else {
        if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
            $ip = $_SERVER['HTTP_CLIENT_IP'];
        } elseif (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
            $ip = $_SERVER['HTTP_X_FORWARDED_FOR'];
        } else {
            $ip = $_SERVER['REMOTE_ADDR'];
        }
    }

    return $ip;
}

function getTime($time)
{
    return date("d.m.Y H:i:s", $time);
}

function getMerchants()
{
    $dir = opendir(LD_PAYMENTS_DIR);
    $array = NULL;

    while ($file = readdir($dir)) {
        if (is_dir(LD_PAYMENTS_DIR . '/' . $file) && $file != '.' && $file != '..') {
            if (file_exists(LD_PAYMENTS_DIR . '/' . $file . '/config.php') &&
                file_exists(LD_PAYMENTS_DIR . '/' . $file . '/result.php') &&
                file_exists(LD_PAYMENTS_DIR . '/' . $file . '/form.php') &&
                file_exists(LD_PAYMENTS_DIR . '/' . $file . '/icon.png')
            ) {
                $array[] = $file;
            }
        }
    }

    return $array;
}

$merchantsArray = getMerchants();

if (!empty($merchantsArray)) {
    foreach ($merchantsArray as $merchant) {
        require(LD_PAYMENTS_DIR . '/' . $merchant . "/config.php");
    }
}

function saveMerchant($m)
{
    global ${$m};

    $txt = '<?php' . PHP_EOL;
    $txt .= 'if (!defined("TKM")) die("<pre>Access denied!</pre>");' . PHP_EOL;
    $txt .= "//Generated with love!" . PHP_EOL;
    $txt .= '$' . $m . ' = ' . var_export(${$m}, true) . ';' . PHP_EOL;
    $txt .= '?>';

    $result = file_put_contents(LD_PAYMENTS_DIR . '/' . $m . '/config.php', $txt);

    if ($result === false) {
        return false;
    }

    return true;
}

function printFatal($text)
{
    echo '<pre>';
    echo '<b>Произошла фатальная ошибка!</b>' . PHP_EOL;
    echo $text;
    echo '<hr>' . PHP_EOL;
    echo '<a href="https://ldonate.ru/" target="_blank">LDONATE by WhileTeam</a> | Version: ' . LD_VERSION;
    echo '</pre>';
    die;
}